<?xml version='1.0' encoding="ISO-8859-1"?>
<!-- Copyright -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/TR/REC-html40">

<!-- Tutkitaan, mit sarakkeita tuoteriveille tarvitaan. -->
<xsl:variable name="useRowCol1" select="count(//Finvoice/InvoiceRow/ArticleName) + count(//Finvoice/InvoiceRow/RowIdentifier)"/> 
<xsl:variable name="useRowCol2" select="count(//Finvoice/InvoiceRow/ArticleIdentifier) + count(//Finvoice/InvoiceRow/BuyerArticleIdentifier)"/> 
<xsl:variable name="useRowCol3" select="count(//Finvoice/InvoiceRow/DeliveredQuantity) + count(//Finvoice/InvoiceRow/OrderedQuantity)"/> 
<xsl:variable name="useRowCol4" select="count(//Finvoice/InvoiceRow/UnitPriceAmount) + count(//Finvoice/InvoiceRow/RowDeliveryDate) + count(//Finvoice/InvoiceRow/StartDate) + count(//Finvoice/InvoiceRow/EndDate)"/>
<xsl:variable name="useRowCol5" select="count(//Finvoice/InvoiceRow/RowDiscountPercent)"/> 
<xsl:variable name="useRowCol6" select="count(//Finvoice/InvoiceRow/RowVatRatePercent)"/> 
<xsl:variable name="useRowCol7" select="count(//Finvoice/InvoiceRow/RowVatAmount) + count(//Finvoice/InvoiceRow/RowVatExcludedAmount)"/>
<xsl:variable name="useRowCol8" select="count(//Finvoice/InvoiceRow/RowAmount)"/>

<!-- Ksitelln Finvoice. -->
<xsl:template match="/">
    <html>
        <head>
        <title>
			<xsl:value-of select="Finvoice/InvoiceDetails/InvoiceTypeText"/>
			<xsl:if test="(Finvoice/InvoiceDetails/OriginCode = 'Copy') and (count(Finvoice/InvoiceDetails/OriginText) = '1')">
				<xsl:text> (</xsl:text><xsl:value-of select="Finvoice/InvoiceDetails/OriginText"/>)
			</xsl:if>
		</title>
	    </head>
        <body bgcolor="#FFFFFF" text="#000000" link="#0000AA" vlink="#0000AA">
		<xsl:if test="count(Finvoice) != '1'">
			<font size="+2"><b>XML-lasku on tyhj tai virheellinen.</b></font><br/>
		</xsl:if>
		<xsl:if test="count(Finvoice) = '1'">
			<p><center><font size="+2"><b>
			<xsl:value-of select="Finvoice/InvoiceDetails/InvoiceTypeText"/>
			<xsl:if test="(Finvoice/InvoiceDetails/OriginCode = 'Copy') and (count(Finvoice/InvoiceDetails/OriginText) = '1')">
				<xsl:text> (</xsl:text><xsl:value-of select="Finvoice/InvoiceDetails/OriginText"/>)
			</xsl:if>
			</b></font><br/></center></p>
			<br/>
			<!-- Tehdn kolmen sarakkeen taulukko, johon tulostetaan tuoterivien ylpuoliset tiedot. -->
			<table width="100%" cellpadding="0" cellspacing="0">
			<tr valign="top" align="left">
			<!-- Ensimminen sarake -->
			<td width="50%"><font size="-1">
			Myyj:<br/>
			<xsl:value-of select="Finvoice/SellerPartyDetails/SellerOrganisationName"/><br/>
			<xsl:if test="string-length(Finvoice/SellerContactPersonName) != 0">
				<xsl:value-of select="Finvoice/SellerContactPersonName"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/SellerCommunicationDetails/SellerEmailaddressIdentifier) != 0">
				<xsl:value-of select="Finvoice/SellerCommunicationDetails/SellerEmailaddressIdentifier"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/SellerCommunicationDetails/SellerPhoneNumberIdentifier) != 0">
				<xsl:value-of select="Finvoice/SellerCommunicationDetails/SellerPhoneNumberIdentifier"/><br/>
			</xsl:if>
			<br/>
			<br/>
			<xsl:if test="count(Finvoice/InvoiceRecipientPartyDetails) != 0">
				<xsl:value-of select="Finvoice/InvoiceRecipientPartyDetails/InvoiceRecipientOrganisationName"/><br/>
				<xsl:if test="string-length(Finvoice/InvoiceRecipientPartyDetails/InvoiceRecipientPostalAddressDetails/InvoiceRecipientPostOfficeBoxIdentifier) != 0">
					<xsl:value-of select="Finvoice/InvoiceRecipientPartyDetails/InvoiceRecipientPostalAddressDetails/InvoiceRecipientPostOfficeBoxIdentifier"/><br/>
				</xsl:if>
				<xsl:value-of select="Finvoice/InvoiceRecipientPartyDetails/InvoiceRecipientPostalAddressDetails/InvoiceRecipientStreetName"/><br/>
				<xsl:value-of select="Finvoice/InvoiceRecipientPartyDetails/InvoiceRecipientPostalAddressDetails/InvoiceRecipientPostCodeIdentifier"/><xsl:text> </xsl:text><xsl:value-of select="Finvoice/InvoiceRecipientPartyDetails/InvoiceRecipientPostalAddressDetails/InvoiceRecipientTownName"/><br/>
			</xsl:if>
			<br/>
			<br/>
			Ostaja:<br/>
			<xsl:value-of select="Finvoice/BuyerPartyDetails/BuyerOrganisationName"/><br/>
			<xsl:if test="string-length(Finvoice/BuyerPartyDetails/BuyerPostalAddressDetails/BuyerPostOfficeBoxIdentifier) != 0">
				<xsl:value-of select="Finvoice/BuyerPartyDetails/BuyerPostalAddressDetails/BuyerPostOfficeBoxIdentifier"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerPartyDetails/BuyerPostalAddressDetails/BuyerStreetName) != 0">
				<xsl:value-of select="Finvoice/BuyerPartyDetails/BuyerPostalAddressDetails/BuyerStreetName"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerPartyDetails/BuyerPostalAddressDetails/BuyerPostCodeIdentifier) != 0">
				<xsl:value-of select="Finvoice/BuyerPartyDetails/BuyerPostalAddressDetails/BuyerPostCodeIdentifier"/><xsl:text> </xsl:text><xsl:value-of select="Finvoice/BuyerPartyDetails/BuyerPostalAddressDetails/BuyerTownName"/><br/>
			</xsl:if>
			<br/>
			<xsl:if test="string-length(Finvoice/BuyerContactPersonName) != 0">
				<xsl:value-of select="Finvoice/BuyerContactPersonName"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerCommunicationDetails/BuyerEmailaddressIdentifier) != 0">
				<xsl:value-of select="Finvoice/BuyerCommunicationDetails/BuyerEmailaddressIdentifier"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerCommunicationDetails/BuyerPhoneNumberIdentifier) != 0">
				<xsl:value-of select="Finvoice/BuyerCommunicationDetails/BuyerPhoneNumberIdentifier"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerPartyDetails/BuyerOrganisationTaxCode) != 0">
				<xsl:value-of select="Finvoice/BuyerPartyDetails/BuyerOrganisationTaxCode"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerOrganisationUnitNumber) != 0">
				<xsl:value-of select="Finvoice/BuyerOrganisationUnitNumber"/><br/>
			</xsl:if>
			</font></td>
			<!-- Toinen sarake -->
			<td width="20%"><font size="-1">
			<br/>
			Laskun pivys:<br/>
			Laskun numero:<br/>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/SellerReferenceIdentifier) != 0">
				Myyjn viite:<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/OrderIdentifier) != 0">
				Tilaus / sopimus:<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerPartyDetails/BuyerPartyIdentifier) != 0">
				Ostajan asiakasnro:<br/>
			</xsl:if>
			<br/>
			Laskun erpiv:<br/>
			Laskun mr:<br/>
			Saajan pankkitili:<br/>
			<xsl:if test="string-length(Finvoice/EpiDetails/EpiPartyDetails/EpiBeneficiaryPartyDetails/EpiNameAddressDetails) != 0">
				Maksun saajan nimi:<br/>
			</xsl:if>
			Viitenumero:<br/>
			<br/>
			<xsl:if test="string-length(Finvoice/PaymentStatusDetails/PaymentStatusCode) != 0">
				Maksun tilanne:<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/PaymentStatusDetails/PaymentMethodText) != 0">
				Maksutapa:<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentTermsFreeText) != 0">
				Maksuehto:<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentOverDueFineDetails/PaymentOverDueFineFreeText) != 0">
				Viivstystiedot:<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentOverDueFineDetails/PaymentOverDueFinePercent) != 0">
				Viivstyskorko:<br/>
			</xsl:if>
			<br/>
			<xsl:if test="count(Finvoice/DeliveryPartyDetails) != 0">
				Toimitusosoite:<br/>
				<xsl:if test="string-length(Finvoice/DeliveryPartyDetails/DeliveryPostalAddressDetails/DeliveryPostofficeBoxIdentifier) != 0">
					<br/>
				</xsl:if>
				<br/>
				<br/>
			</xsl:if>
			<xsl:choose>
			<xsl:when test="string-length(Finvoice/DeliveryDetails/DeliveryDate) != 0">
				Toimituspiv:<br/>
			</xsl:when>
			<xsl:when test="string-length(Finvoice/DeliveryDetails/DeliveryPeriodDetails) != 0">
				Toimitusjakso:<br/><br/> <!-- Jakso tulostetaan kahdelle riville, jotta sekunnitkin mahtuisivat. -->
			</xsl:when>
			</xsl:choose>
			<xsl:if test="string-length(Finvoice/DeliveryDetails/DeliveryMethodText) != 0">
				Toimitustapa:<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/DeliveryDetails/DeliveryTermsText) != 0">
				Toimitusehdot:<br/>
			</xsl:if>
			<br/>
			</font></td>
			<!-- Kolmas sarake -->
			<td width="30%"><font size="-1">
			<br/>
			<xsl:call-template name='OutputDate'>
				<xsl:with-param name='theDate' select="Finvoice/InvoiceDetails/InvoiceDate"/>
				<xsl:with-param name='theFormat' select="Finvoice/InvoiceDetails/InvoiceDate/@Format"/>
			</xsl:call-template><br/>
			<xsl:value-of select="Finvoice/InvoiceDetails/InvoiceNumber"/><br/>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/SellerReferenceIdentifier) != 0">
				<xsl:value-of select="Finvoice/InvoiceDetails/SellerReferenceIdentifier"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/OrderIdentifier) != 0">
				<xsl:value-of select="Finvoice/InvoiceDetails/OrderIdentifier"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/BuyerPartyDetails/BuyerPartyIdentifier) != 0">
				<xsl:value-of select="Finvoice/BuyerPartyDetails/BuyerPartyIdentifier"/><br/>
			</xsl:if>
			<br/>
			<xsl:call-template name='OutputDate'>
				<xsl:with-param name='theDate' select="Finvoice/InvoiceDetails/PaymentTermsDetails/InvoiceDueDate"/>
				<xsl:with-param name='theFormat' select="Finvoice/InvoiceDetails/PaymentTermsDetails/InvoiceDueDate/@Format"/>
			</xsl:call-template>
			<br/>
			<xsl:call-template name='OutputAmount'>
				<xsl:with-param name='amount' select="Finvoice/InvoiceDetails/InvoiceTotalVatIncludedAmount"/>
				<xsl:with-param name='currency' select="Finvoice/InvoiceDetails/InvoiceTotalVatIncludedAmount/@AmountCurrencyIdentifier"/>
			</xsl:call-template>
			<br/>
			<xsl:call-template name='OutputEpiAccountID'>
				<xsl:with-param name='scheme' select="Finvoice/EpiDetails/EpiPartyDetails/EpiBeneficiaryPartyDetails/EpiAccountID/@IdentificationSchemeName"/>
				<xsl:with-param name='account' select="Finvoice/EpiDetails/EpiPartyDetails/EpiBeneficiaryPartyDetails/EpiAccountID"/>
			</xsl:call-template>
			<br/>
			<xsl:if test="string-length(Finvoice/EpiDetails/EpiPartyDetails/EpiBeneficiaryPartyDetails/EpiNameAddressDetails) != 0">
				<xsl:value-of select="Finvoice/EpiDetails/EpiPartyDetails/EpiBeneficiaryPartyDetails/EpiNameAddressDetails"/><br/>
			</xsl:if>
			<xsl:value-of select="Finvoice/EpiDetails/EpiPaymentInstructionDetails/EpiRemittanceInfoIdentifier"/><br/>
			<br/>
			<xsl:if test="string-length(Finvoice/PaymentStatusDetails/PaymentStatusCode) != 0">
				<xsl:choose>
				<xsl:when test="Finvoice/PaymentStatusDetails/PaymentStatusCode = 'NOTPAID'">Maksettava</xsl:when>
				<xsl:when test="Finvoice/PaymentStatusDetails/PaymentStatusCode = 'PARTLYPAID'">Osa maksettu</xsl:when>
				<xsl:when test="Finvoice/PaymentStatusDetails/PaymentStatusCode = 'PAID'">Maksettu</xsl:when>
				<xsl:otherwise><xsl:value-of select="Finvoice/PaymentStatusDetails/PaymentStatusCode"/></xsl:otherwise>
				</xsl:choose>
				<br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/PaymentStatusDetails/PaymentMethodText) != 0">
				<xsl:value-of select="Finvoice/PaymentStatusDetails/PaymentMethodText"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentTermsFreeText) != 0">
				<xsl:value-of select="Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentTermsFreeText"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentOverDueFineDetails/PaymentOverDueFineFreeText) != 0">
				<xsl:value-of select="Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentOverDueFineDetails/PaymentOverDueFineFreeText"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentOverDueFineDetails/PaymentOverDueFinePercent) != 0">
				<xsl:value-of select="Finvoice/InvoiceDetails/PaymentTermsDetails/PaymentOverDueFineDetails/PaymentOverDueFinePercent"/><br/>
			</xsl:if>
			<br/>
			<xsl:if test="count(Finvoice/DeliveryPartyDetails) != 0">
				<xsl:value-of select="Finvoice/DeliveryPartyDetails/DeliveryOrganisationName"/><br/>
				<xsl:if test="string-length(Finvoice/DeliveryPartyDetails/DeliveryPostalAddressDetails/DeliveryPostofficeBoxIdentifier) != 0">
					<xsl:value-of select="Finvoice/DeliveryPartyDetails/DeliveryPostalAddressDetails/DeliveryPostofficeBoxIdentifier"/><br/>
				</xsl:if>
				<xsl:value-of select="Finvoice/DeliveryPartyDetails/DeliveryPostalAddressDetails/DeliveryStreetName"/><br/>
				<xsl:value-of select="Finvoice/DeliveryPartyDetails/DeliveryPostalAddressDetails/DeliveryPostCodeIdentifier"/><xsl:text> </xsl:text><xsl:value-of select="Finvoice/DeliveryPartyDetails/DeliveryPostalAddressDetails/DeliveryTownName"/><br/>
			</xsl:if>
			<xsl:choose>
			<xsl:when test="string-length(Finvoice/DeliveryDetails/DeliveryDate) != 0">
				<xsl:call-template name='OutputDate'>
					<xsl:with-param name='theDate' select="Finvoice/DeliveryDetails/DeliveryDate"/>
					<xsl:with-param name='theFormat' select="Finvoice/DeliveryDetails/DeliveryDate/@Format"/>
				</xsl:call-template>
				<br/>
			</xsl:when>
			<xsl:when test="string-length(Finvoice/DeliveryDetails/DeliveryPeriodDetails) != 0">
				<xsl:call-template name='OutputDate'>
					<xsl:with-param name='theDate' select="Finvoice/DeliveryDetails/DeliveryPeriodDetails/StartDate"/>
					<xsl:with-param name='theFormat' select="Finvoice/DeliveryDetails/DeliveryPeriodDetails/StartDate/@Format"/>
				</xsl:call-template>
				-<br/> <!-- Jakso tulostetaan kahdelle riville, jotta sekunnitkin mahtuisivat. -->
				<xsl:call-template name='OutputDate'>
					<xsl:with-param name='theDate' select="Finvoice/DeliveryDetails/DeliveryPeriodDetails/EndDate"/>
					<xsl:with-param name='theFormat' select="Finvoice/DeliveryDetails/DeliveryPeriodDetails/EndDate/@Format"/>
				</xsl:call-template>
				<br/>
			</xsl:when>
			</xsl:choose>
			<xsl:if test="string-length(Finvoice/DeliveryDetails/DeliveryMethodText) != 0">
				<xsl:value-of select="Finvoice/DeliveryDetails/DeliveryMethodText"/><br/>
			</xsl:if>
			<xsl:if test="string-length(Finvoice/DeliveryDetails/DeliveryTermsText) != 0">
				<xsl:value-of select="Finvoice/DeliveryDetails/DeliveryTermsText"/><br/>
			</xsl:if>
			<br/>
			</font></td>
			<!-- Kolmas sarake loppui -->
			</tr>
			<xsl:if test="string-length(Finvoice/InvoiceDetails/InvoiceFreeText) != 0">
				<tr valign="top" align="left">
				<td width="50%"><font size="-1"></font></td>
				<td colspan="2"><font size="-1"><xsl:value-of select="Finvoice/InvoiceDetails/InvoiceFreeText"/></font></td>
				</tr>
			</xsl:if>
			</table>
			<!--
			Tehdn tuoteriveille taulukko, johon tulee sarakkeita aiemmin ptelty mr.
			-->
			<table width="100%" cellpadding="2" cellspacing="0">
			<tr><td colspan="8"><hr/></td></tr>
			<tr align="left" valign="top">
			<xsl:if test="$useRowCol1 &gt; 0">
				<td><font size="-2"><b>Tuote/palvelu<br/>Tilausviite</b></font></td>
			</xsl:if>
			<xsl:if test="$useRowCol2 &gt; 0">
				<td><font size="-2"><b>Tuotenumero<br/>Ostajan tuotenro</b></font></td>
			</xsl:if>
			<xsl:if test="$useRowCol3 &gt; 0">
				<td><font size="-2"><b>Toimitettu mr<br/>Tilattu mr</b></font></td>
			</xsl:if>
			<xsl:if test="$useRowCol4 &gt; 0">
				<td><font size="-2"><b>a-hinta<br/>Toimituspiv</b></font></td>
			</xsl:if>
			<xsl:if test="$useRowCol5 &gt; 0">
				<td align="right"><font size="-2"><b>Alennus%</b></font></td>
			</xsl:if>
			<xsl:if test="$useRowCol6 &gt; 0">
				<td align="right"><font size="-2"><b>Alv%</b></font></td>
			</xsl:if>
			<xsl:if test="$useRowCol7 &gt; 0">
				<td align="right"><font size="-2"><b>Alv-mr<br/>Veroton mr</b></font></td>
			</xsl:if>
			<xsl:if test="$useRowCol8 &gt; 0">
				<td align="right"><font size="-2"><b>Yhteens</b></font></td>
			</xsl:if>
			</tr>
			<tr><td colspan="8"><hr/></td></tr>
			<xsl:for-each select="Finvoice/InvoiceRow">
				<tr>
				<xsl:if test="$useRowCol1 &gt; 0">
					<td><font size="-2"><xsl:value-of select="ArticleName"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol2 &gt; 0">
					<td><font size="-2"><xsl:value-of select="ArticleIdentifier"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol3 &gt; 0">
					<td><font size="-2"><xsl:value-of select="DeliveredQuantity"/><xsl:text> </xsl:text><xsl:value-of select="DeliveredQuantity/@QuantityUnitCode"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol4 &gt; 0">
					<td><font size="-2"><xsl:value-of select="UnitPriceAmount"/><xsl:text> </xsl:text><xsl:value-of select="UnitPriceAmount/@UnitPriceUnitCode"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol5 &gt; 0">
					<td align="right"><font size="-2"><xsl:value-of select="RowDiscountPercent"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol6 &gt; 0">
					<td align="right"><font size="-2"><xsl:value-of select="RowVatRatePercent"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol7 &gt; 0">
					<td align="right"><font size="-2"><xsl:value-of select="RowVatAmount"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol8 &gt; 0">
					<td align="right"><font size="-2"><xsl:value-of select="RowAmount"/></font></td>
				</xsl:if>
				</tr>
				<tr>
				<xsl:if test="$useRowCol1 &gt; 0">
					<td><font size="-2"><xsl:value-of select="RowIdentifier"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol2 &gt; 0">
					<td><font size="-2"><xsl:value-of select="BuyerArticleIdentifier"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol3 &gt; 0">
					<td><font size="-2"><xsl:value-of select="OrderedQuantity"/><xsl:text> </xsl:text><xsl:value-of select="OrderedQuantity/@QuantityUnitCode"/></font></td>
				</xsl:if>
				<xsl:if test="$useRowCol4 &gt; 0">
					<xsl:choose>
					<xsl:when test="$useRowCol5 &gt; 0">
						<xsl:choose>
						<xsl:when test="$useRowCol6 &gt; 0">
							<xsl:call-template name='OutputDeliveryDate3'/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name='OutputDeliveryDate2'/>
						</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
						<xsl:when test="$useRowCol6 &gt; 0">
							<xsl:call-template name='OutputDeliveryDate2'/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name='OutputDeliveryDate1'/>
						</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
				<xsl:if test="$useRowCol7 &gt; 0">
					<td align="right"><font size="-2"><xsl:value-of select="RowVatExcludedAmount"/></font></td>
				</xsl:if>
				</tr>
				<xsl:if test="count(RowIdentifierDate) &gt; 0">
					<tr><td colspan="8"><font size="-2">
					<b>Tilauspiv: </b>
					<xsl:call-template name='OutputDate'>
						<xsl:with-param name='theDate' select="RowIdentifierDate"/>
						<xsl:with-param name='theFormat' select="RowIdentifierDate/@Format"/>
					</xsl:call-template>
					</font></td></tr>
				</xsl:if>
				<xsl:if test="(count(RowShortProposedAccountIdentifier) &gt; 0) or (count(RowNormalProposedAccountIdentifier) &gt; 0) or (count(RowAccountDimensionText) &gt; 0)">
					<tr><td colspan="8"><font size="-2">
					<b>Tiliintiehdotus: </b>
					<xsl:if test="count(RowShortProposedAccountIdentifier) &gt; 0">
						<xsl:value-of select="RowShortProposedAccountIdentifier"/>
						<xsl:if test="(count(RowNormalProposedAccountIdentifier) &gt; 0) or (count(RowAccountDimensionText) &gt; 0)">
							<xsl:text>, </xsl:text>
						</xsl:if>
					</xsl:if>
					<xsl:if test="count(RowNormalProposedAccountIdentifier) &gt; 0">
						<xsl:value-of select="RowNormalProposedAccountIdentifier"/>
						<xsl:if test="count(RowAccountDimensionText) &gt; 0">
							<xsl:text>, </xsl:text>
						</xsl:if>
					</xsl:if>
					<xsl:if test="count(RowAccountDimensionText) &gt; 0">
						<xsl:value-of select="RowAccountDimensionText"/>
					</xsl:if>
					</font></td></tr>
				</xsl:if>
				<xsl:for-each select="RowFreeText">
					<tr><td colspan="8"><font size="-2"><xsl:value-of select="."/></font></td></tr>
				</xsl:for-each>
			</xsl:for-each>
			</table>
			<!-- Tuoterivit on nyt tulostettu. -->
			<br/><br/>
			<p align="right"><b>LASKU YHTEENS:<xsl:text> </xsl:text>
			<xsl:call-template name='OutputAmount'>
				<xsl:with-param name='amount' select="Finvoice/InvoiceDetails/InvoiceTotalVatIncludedAmount"/>
				<xsl:with-param name='currency' select="Finvoice/InvoiceDetails/InvoiceTotalVatIncludedAmount/@AmountCurrencyIdentifier"/>
			</xsl:call-template>
			</b><br/><br/><br/></p>
			<!-- Tulostetaan alv-erittely, jos sellainen laskulta lytyy. -->
			<xsl:choose>
			<xsl:when test="count(//Finvoice/InvoiceDetails/VatSpecificationDetails) != 0">
				<p>
				<table width="90%" cellpadding="1" cellspacing="0">
				<tr align="left">
				<td width="60%"></td>
				<td><font size="-1"><b>ALV-erittely:</b></font></td>
				<td width="1%"></td>
				<td></td>
				</tr>
				<tr align="left">
				<td width="60%"></td>
				<td><font size="-1">Veroton mr:</font></td>
				<td width="1%"></td>
				<td align="right"><font size="-1"><xsl:value-of select="Finvoice/InvoiceDetails/InvoiceTotalVatExcludedAmount"/></font></td>
				</tr>
				<xsl:for-each select="Finvoice/InvoiceDetails/VatSpecificationDetails">
					<tr align="left">
					<td width="60%"></td>
					<td ><font size="-1">Alv<xsl:text> </xsl:text>
					<xsl:value-of select="VatRatePercent"/>
					<xsl:text> %:</xsl:text></font></td>
					<td width="1%"></td>
					<td align="right"><font size="-1"><xsl:value-of select="VatRateAmount"/></font></td>
					</tr>
				</xsl:for-each>
				</table>
				</p>
			</xsl:when>
			</xsl:choose>
			<!-- Tulostetaan tiliintiehdotukset ja kustannuspaikka, jos ne laskulta lytyvt. -->
			<xsl:if test="(count(Finvoice/InvoiceDetails/ShortProposedAccountIdentifier) != 0) or (count(Finvoice/InvoiceDetails/NormalProposedAccountIdentifier) != 0) or (count(Finvoice/InvoiceDetails/AccountDimensionText) != 0)">
				<p>
				<table width="90%" cellpadding="1" cellspacing="0">
				<tr align="left">
				<td width="60%"></td>
				<td><font size="-1">Tiliintiehdotus (lyhyt):</font></td>
				<td width="1%"></td>
				<td align="right"><font size="-1"><xsl:value-of select="Finvoice/InvoiceDetails/ShortProposedAccountIdentifier"/></font></td>
				</tr>
				<tr align="left">
				<td width="60%"></td>
				<td><font size="-1">Tiliintiehdotus (norm):</font></td>
				<td width="1%"></td>
				<td align="right"><font size="-1"><xsl:value-of select="Finvoice/InvoiceDetails/NormalProposedAccountIdentifier"/></font></td>
				</tr>
				<tr align="left">
				<td width="60%"></td>
				<td><font size="-1">Kustannuspaikka:</font></td>
				<td width="1%"></td>
				<td align="right"><font size="-1"><xsl:value-of select="Finvoice/InvoiceDetails/AccountDimensionText"/></font></td>
				</tr>
				</table>
				</p>
			</xsl:if>
			<!-- Tulostetaan virtuaaliviivakoodi, jos sellainen laskulta lytyy. -->
			<xsl:if test="count(Finvoice/VirtualBankBarcode) != 0">
				<p>
				<center><b>Virtuaaliviivakoodi:</b><br/><xsl:value-of select="Finvoice/VirtualBankBarcode"/></center>
				</p>
			</xsl:if>
			<p>
			<!-- Sitten tulostetaan mahdolliset osamaksutiedot. -->
			<xsl:for-each select="Finvoice/PartialPaymentDetails">
				<table width="100%" cellpadding="1" cellspacing="0">
				<xsl:if test="count(PaidAmount)+count(UnPaidAmount)+count(InterestPercent)+count(ProsessingCostsAmount) != 0">
					<tr align="left"><td><font size="-1"><b>Osamaksun tiedot:</b></font></td></tr>
				</xsl:if>
				<xsl:choose>
				<xsl:when test="count(PaidAmount) != 0">
					<td><font size="-1"><xsl:text>Maksettu mr: </xsl:text><xsl:value-of select="PaidAmount"/></font></td>
				</xsl:when>
				<xsl:otherwise>
					<td></td>
				</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
				<xsl:when test="count(UnPaidAmount) != 0">
					<td align="right"><font size="-1"><xsl:text>Maksamaton mr: </xsl:text><xsl:value-of select="UnPaidAmount"/></font></td>
				</xsl:when>
				<xsl:otherwise>
					<td></td>
				</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
				<xsl:when test="count(InterestPercent) != 0">
					<td align="right"><font size="-1"><xsl:text>Korkokanta: </xsl:text><xsl:value-of select="InterestPercent"/></font></td>
				</xsl:when>
				<xsl:otherwise>
					<td></td>
				</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
				<xsl:when test="count(ProsessingCostsAmount) != 0">
					<td align="right"><font size="-1"><xsl:text>Toimitusmaksu: </xsl:text><xsl:value-of select="ProsessingCostsAmount"/></font></td>
				</xsl:when>
				<xsl:otherwise>
					<td></td>
				</xsl:otherwise>
				</xsl:choose>
				<td width="30%"><font size="-1"><br/></font></td>
				<tr align="left">
				<td><font size="-1"><b>Osamaksun erpiv</b></font></td>
				<td align="right"><font size="-1"><b>Verollinen mr</b></font></td>
				<td align="right"><font size="-1"><b>Veroton mr</b></font></td>
				<td align="right"><font size="-1"><b>Osamaksun viitenro</b></font></td>
				<td width="30%"><font size="-1"><br/></font></td>
				</tr>
				<tr align="left">
				<td><font size="-1">
				<xsl:for-each select="PartialPaymentDueDate">
					<xsl:call-template name='OutputDate'>
						<xsl:with-param name='theDate' select="."/>
						<xsl:with-param name='theFormat' select="@Format"/>
					</xsl:call-template>
					<br/>
				</xsl:for-each>
				</font></td>
				<td align="right"><font size="-1">
				<xsl:for-each select="PartialPaymentVatIncludedAmount">
					<xsl:value-of select="."/>
					<br/>
				</xsl:for-each>
				</font></td>
				<td align="right"><font size="-1">
				<xsl:for-each select="PartialPaymentVatExcludedAmount">
					<xsl:value-of select="."/>
					<br/>
				</xsl:for-each>
				</font></td>
				<td align="right"><font size="-1">
				<xsl:for-each select="PartialPaymentReferenceIdentifier">
					<xsl:value-of select="."/>
					<br/>
				</xsl:for-each>
				</font></td>
				<td width="30%"><font size="-1"><br/></font></td>
				</tr>
				</table>
			</xsl:for-each>
			<!-- Loppuun tulostetaan myyjn yhteys- ja muita tietoja. -->
			<table width="100%" cellpadding="1" cellspacing="0">
			<tr><td colspan="3"><hr/></td></tr>
			<tr align="left" valign="top">
			<td><font size="-3">
			<xsl:value-of select="Finvoice/SellerPartyDetails/SellerOrganisationName"/><br/>
			<xsl:if test="count(Finvoice/SellerPartyDetails/SellerPostalAddressDetails/SellerStreetName) != 0">
				<xsl:value-of select="Finvoice/SellerPartyDetails/SellerPostalAddressDetails/SellerStreetName"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerPartyDetails/SellerPostalAddressDetails/SellerPostCodeIdentifier) + count(Finvoice/SellerPartyDetails/SellerPostalAddressDetails/SellerTownName) != 0">
				<xsl:value-of select="Finvoice/SellerPartyDetails/SellerPostalAddressDetails/SellerPostCodeIdentifier"/>
				<xsl:text> </xsl:text>
				<xsl:value-of select="Finvoice/SellerPartyDetails/SellerPostalAddressDetails/SellerTownName"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerPartyDetails/SellerPostalAddressDetails/CountryName) != 0">
				<xsl:value-of select="Finvoice/SellerPartyDetails/SellerPostalAddressDetails/CountryName"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerInformationDetails/SellerFreeText) != 0">
				<xsl:value-of select="Finvoice/SellerInformationDetails/SellerFreeText"/>
			</xsl:if>
			</font></td>
			<td><font size="-3">
			<xsl:if test="count(Finvoice/SellerInformationDetails/SellerPhoneNumber) != 0">
				<xsl:text>Puhelin: </xsl:text><xsl:value-of select="Finvoice/SellerInformationDetails/SellerPhoneNumber"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerInformationDetails/SellerFaxNumber) != 0">
				<xsl:text>Telefax: </xsl:text><xsl:value-of select="Finvoice/SellerInformationDetails/SellerFaxNumber"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerInformationDetails/SellerWebaddressIdentifier) != 0">
				<xsl:text>WWW-osoite: </xsl:text><xsl:value-of select="Finvoice/SellerInformationDetails/SellerWebaddressIdentifier"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerInformationDetails/SellerCommonEmailaddressIdentifier) != 0">
				<xsl:text>Shkposti: </xsl:text><xsl:value-of select="Finvoice/SellerInformationDetails/SellerCommonEmailaddressIdentifier"/>
			</xsl:if>
			</font></td>
			<td><font size="-3">
			<xsl:if test="count(Finvoice/SellerInformationDetails/SellerHomeTownName) != 0">
				<xsl:text>Kotipaikka: </xsl:text><xsl:value-of select="Finvoice/SellerInformationDetails/SellerHomeTownName"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerPartyDetails/SellerOrganisationTaxCode) != 0">
				<xsl:text>Y-tunnus: </xsl:text><xsl:value-of select="Finvoice/SellerPartyDetails/SellerOrganisationTaxCode"/><br/>
			</xsl:if>
			<xsl:if test="count(Finvoice/SellerInformationDetails/SellerVatRegistrationText) + count(Finvoice/SellerInformationDetails/SellerVatRegistrationDate) != 0">
				<xsl:value-of select="Finvoice/SellerInformationDetails/SellerVatRegistrationText"/><xsl:text> </xsl:text>
				<xsl:call-template name='OutputDate'>
					<xsl:with-param name='theDate' select="Finvoice/SellerInformationDetails/SellerVatRegistrationDate"/>
					<xsl:with-param name='theFormat' select="Finvoice/SellerInformationDetails/SellerVatRegistrationDate/@Format"/>
				</xsl:call-template>
			</xsl:if>
			<xsl:for-each select="Finvoice/SellerInformationDetails/SellerAccountDetails">
				<br/>
				<xsl:call-template name='OutputEpiAccountID'>
					<xsl:with-param name='scheme' select="SellerAccountID/@IdentificationSchemeName"/>
					<xsl:with-param name='account' select="SellerAccountID"/>
				</xsl:call-template>
				<xsl:text> / </xsl:text><xsl:value-of select="SellerBic"/>
			</xsl:for-each>
			</font></td>
			</tr>
			</table>
			</p>
		</xsl:if>
        </body>
    </html>
</xsl:template>

<!-- Template, joka tulostaa toimitusajan 1 sarakkeen alueelle. -->
<xsl:template name='OutputDeliveryDate1'>
	<td>
	<xsl:call-template name='OutputDeliveryDate'/>
	</td>
</xsl:template>

<!-- Template, joka tulostaa toimitusajan 2 sarakkeen alueelle. -->
<xsl:template name='OutputDeliveryDate2'>
	<td colspan="2">
	<xsl:call-template name='OutputDeliveryDate'/>
	</td>
</xsl:template>

<!-- Template, joka tulostaa toimitusajan 3 sarakkeen alueelle. -->
<xsl:template name='OutputDeliveryDate3'>
	<td colspan="3">
	<xsl:call-template name='OutputDeliveryDate'/>
	</td>
</xsl:template>

<!-- Template, joka tulostaa toimitusajan. -->
<xsl:template name='OutputDeliveryDate'>
	<font size="-2">
	<xsl:choose>
	<xsl:when test="count(RowDeliveryDate) &gt; 0">
		<xsl:call-template name='OutputDate'>
			<xsl:with-param name='theDate' select="RowDeliveryDate"/>
			<xsl:with-param name='theFormat' select="RowDeliveryDate/@Format"/>
		</xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
		<xsl:if test="count(StartDate) &gt; 0">
			<xsl:call-template name='OutputDate'>
				<xsl:with-param name='theDate' select="StartDate"/>
				<xsl:with-param name='theFormat' select="StartDate/@Format"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:if test="count(EndDate) &gt; 0">
			-
			<xsl:call-template name='OutputDate'>
				<xsl:with-param name='theDate' select="EndDate"/>
				<xsl:with-param name='theFormat' select="EndDate/@Format"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:otherwise>
	</xsl:choose>
	</font>
</xsl:template>

<!-- Template, joka osaa tulostaa pivmri. -->
<xsl:template name='OutputDate'>
	<xsl:param name='theDate'/>
	<xsl:param name='theFormat'/>
	<xsl:if test="string-length($theDate) != 0">
		<xsl:choose>
		<xsl:when test="substring($theDate,7,1)='0'">
			<xsl:value-of select="substring($theDate,8,1)"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="substring($theDate,7,2)"/>
		</xsl:otherwise>
		</xsl:choose>
		.
		<xsl:choose>
		<xsl:when test="substring($theDate,5,1)='0'">
			<xsl:value-of select="substring($theDate,6,1)"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="substring($theDate,5,2)"/>
		</xsl:otherwise>
		</xsl:choose>
		.
		<xsl:value-of select="substring($theDate,1,4)"/>
		<xsl:if test="$theFormat = 'CCYYMMDDHHMMSS'">
			<xsl:text> </xsl:text>
			<xsl:value-of select="substring($theDate,9,2)"/>
			:
			<xsl:value-of select="substring($theDate,11,2)"/>
			<!--<xsl:if test="substring($theDate,13,2)!='00'"> -->
				:
				<xsl:value-of select="substring($theDate,13,2)"/>
			<!--</xsl:if>-->
		</xsl:if>
	</xsl:if>
</xsl:template>

<!-- Template, joka osaa tulostaa tilinumeroita (IBAN ryhmiteltyn ja muut sellaisenaan). -->
<xsl:template name='OutputEpiAccountID'>
	<xsl:param name='scheme'/>
	<xsl:param name='account'/>
	<xsl:variable name="lenAccount" select="string-length($account)"/>
	<xsl:choose>
	<xsl:when test="$scheme = 'IBAN'">
		<xsl:choose>
		<xsl:when test="$lenAccount &lt; 5">
			<xsl:value-of select="$account"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="substring($account, 1, 4)"/><xsl:text> </xsl:text>
			<xsl:choose>
			<xsl:when test="$lenAccount &lt; 9">
				<xsl:value-of select="substring($account, 5, $lenAccount - 4)"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="substring($account, 5, 4)"/><xsl:text> </xsl:text>
				<xsl:choose>
				<xsl:when test="$lenAccount &lt; 13">
					<xsl:value-of select="substring($account, 9, $lenAccount - 8)"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="substring($account, 9, 4)"/><xsl:text> </xsl:text>
					<xsl:choose>
					<xsl:when test="$lenAccount &lt; 17">
						<xsl:value-of select="substring($account, 13, $lenAccount - 12)"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="substring($account, 13, 4)"/><xsl:text> </xsl:text>
						<xsl:choose>
						<xsl:when test="$lenAccount &lt; 21">
							<xsl:value-of select="substring($account, 17, $lenAccount - 16)"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="substring($account, 17, 4)"/><xsl:text> </xsl:text>
							<xsl:value-of select="substring($account, 21, $lenAccount - 20)"/>
						</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
			</xsl:choose>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="$account"/>
	</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- Template, joka osaa tulostaa rahasumman rahayksikn kera. -->
<xsl:template name='OutputAmount'>
	<xsl:param name='amount'/>
	<xsl:param name='currency'/>
	<xsl:if test="string-length($amount) != 0">
		<xsl:value-of select="$amount"/><xsl:text> </xsl:text>
		<xsl:choose>
		<xsl:when test="$currency = 'EUR'">
			euroa
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$currency"/>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>